datablock AudioProfile(burstcannonShot1Sound)
{
   filename    = "./burstcannonShot.wav"; //39067__alienbomb__cannon-round "Freesound.org"
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BurstcannonHitSound)
{
   filename    = "./Burstcannon_hit.wav";
   description = AudioClose3d;
   preload = true;
};

//muzzle flash effects
datablock ParticleData(BurstcannonFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 25;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.5 1.0 0.9 1.0";
	colors[1]	= "0.0 1.0 0.9 0.5";
	colors[2]	= "0.0 0.2 0.1 0.5";
	sizes[0]      = 2.5;
	sizes[1]      = 1.0;
	sizes[2]      = 0.5;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BurstcannonFlashEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 7.2;
   velocityVariance = 1.2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 2;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BurstcannonFlashParticle";
};

datablock ParticleData(BurstcannonTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 150;
	lifetimeVarianceMS	= 100;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.5 1.0 0.9 1.0";
	colors[1]	= "0.0 1.0 0.9 0.5";
	colors[2]	= "0.0 0.2 0.1 0.5";
	sizes[0]	= 0.75;
	sizes[1]	= 0.25;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.25;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(BurstcannonTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = BurstcannonTrailParticle;
};

datablock ParticleData(BurstcannonExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 450;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.5 1.0 0.9 0.5";
	colors[1]     = "0.0 1.0 0.9 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 1.25;

	useInvAlpha = true;
};
datablock ParticleEmitterData(BurstcannonExplosionEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BurstcannonExplosionParticle";

};

datablock ParticleData(BurstcannonExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/lighting/flare.jpg";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 1.0 0.9 0.5";
	colors[1]     = "0.0 1.0 0.9 0.0";
	sizes[0]      = 4.0;
	sizes[1]      = 1.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BurstcannonExplosionRingEmitter)
{
	lifeTimeMS = 300;

   ejectionPeriodMS = 12;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BurstcannonExplosionRingParticle";

};

datablock ExplosionData(burstcannonExplosion)
{
   //explosionShape = "";
	soundProfile = burstcannonHitSound;

   lifeTimeMS = 150;

   particleEmitter = burstcannonExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = burstcannonExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 2;
   lightStartColor = "0.5 1.0 0.9";
   lightEndColor = "0 0 0";
};


AddDamageType("burstcannon",   '<bitmap:add-ons/Player_Mech/CI_burstcannon> %1',    '%2 <bitmap:add-ons/Player_Mech/CI_burstcannon> %1',0.2,1);
datablock ProjectileData(burstcannonProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::burstcannon;
   radiusDamageType    = $DamageType::burstcannon;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400; //400
   verticalImpulse	  = 400; //400
   explosion           = burstcannonExplosion;
   particleEmitter     = burstcannonTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 175; //90
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Burst Cannon Bullet";
};

//////////
// item //
//////////
datablock ItemData(burstcannonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BSburstcannon.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Burst Cannon";
	iconName = "./icon_burstcannon";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = burstcannonImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(burstcannonImage)
{
   // Basic Item properties
   shapeFile = "./BSburstcannon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = burstcannonProjectile;
   projectileType = Projectile;

	casing = burstcannonShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = burstcannonItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateSequence[1]                 = "Ready";
	stateTransitionOnTriggerDown[1]  = "Spin";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                    = "Spin";
	stateTimeoutValue[2]            = 0.4;
	stateSequence[2]                = "Spin";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTransitionOnTriggerUp[2]       = "Ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.04;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= burstcannonFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= burstcannonShot1Sound;
	stateEjectShell[3]       = true;

	stateName[4] = "Smoke";
	stateEmitter[4]					= burstcannonSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.01;
	stateTransitionOnTimeout[4]     = "Reload";

	stateName[5]			= "Reload";
	stateTimeoutValue[5]            = 0.15;
	stateTransitionOnTriggerDown[5]   = "Fire";
	stateTransitionOnTriggerUp[5]     = "Ready";
};

function burstcannonImage::onFire(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);	

	%projectile = burstcannonProjectile;
	
		%spread = 0.008; //0.0035

	
	%shellcount = 1;

	%obj.playThread(2, shiftright);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
