datablock AudioProfile(FusionBlasterShot1Sound)
{
   filename    = "./FusionBlaster_Fire.wav"; 
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FusionBlasterHitSound)
{
   filename    = "./Fusionblaster_hit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(FusionBlasterSmokeParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.5 0.75 1.0 0.5";
	colors[1]	= "0.25 0.5 1.0 0.5";
	colors[2]	= "0 0.5 1.0 0.0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.7;
	sizes[2]	= 0.8;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1;

	useInvAlpha = false;
};

datablock ParticleEmitterData(FusionBlasterSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FusionBlasterSmokeParticle";
};

datablock ParticleData(FusionBlasterTrailParticle)
{
	dragCoefficient		= 1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0625;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 200;
	spinRandomMin		= -1500.0;
	spinRandomMax		= 1500.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.5 0.75 1.0 0.5";
	colors[1]	= "0.25 0.5 1.0 0.5";
	colors[2]	= "0 0.5 1.0 0.0";
	sizes[0]	= 4.0;
	sizes[1]	= 1.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.25;
	times[2]	= 1;
};

datablock ParticleEmitterData(FusionBlasterTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = FusionBlasterTrailParticle;

   useEmitterColors = true;
};

datablock ParticleData(FusionBlasterExplosionParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 50.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]	= "0.5 0.75 1.0 0.5";
	colors[1]	= "0.25 0.5 1.0 0.5";
	colors[2]	= "0 0.5 1.0 0.0";
	sizes[0]      = 2.5;
	sizes[1]      = 5.0;
	sizes[2]      = 7.5;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1;	

	useInvAlpha = false;
};
datablock ParticleEmitterData(FusionBlasterExplosionEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FusionBlasterExplosionParticle";

   useEmitterColors = true;
};

datablock ParticleData(FusionBlasterExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.5 0.75 1.0 0.5";
	colors[1]	= "0.25 0.5 1.0 0.5";
	colors[2]	= "0 0.5 1.0 0.0";
	sizes[0]      = 3.3;
	sizes[1]      = 6.6;
	sizes[2]	  = 10;
	times[0]	= 0.0;
	times[1]	= 0.25;
	times[2]	= 1;	
	
	useInvAlpha = false;
};
datablock ParticleEmitterData(FusionBlasterExplosionRingEmitter)
{
	lifeTimeMS = 300;

   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FusionBlasterExplosionRingParticle";

   useEmitterColors = true;
};

datablock ExplosionData(FusionBlasterExplosion)
{
   //explosionShape = "";
	soundProfile = FusionBlasterHitSound;

   lifeTimeMS = 100;

   particleEmitter = FusionBlasterExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = FusionBlasterExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1.0 1.0 1.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 2.5;
   
   damageRadius = 3; 
   radiusDamage = 0;                                           
   impulseRadius = 2;  
   impulseForce = 100;    
   playerBurnTime = 2000;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "1 0.875 0.75 1";
   lightEndColor = "1 0.25 0 0";
};


datablock ExplosionData(FusionBlasterExplosion)
{
   //explosionShape = "";
	soundProfile = FusionBlasterHitSound;

   lifeTimeMS = 150;

   particleEmitter = FusionBlasterExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = FusionBlasterExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


AddDamageType("FusionBlaster",   '<bitmap:add-ons/player_mech/CI_FusionBlaster> %1',    '%2 <bitmap:add-ons/player_mech/CI_FusionBlaster> %1',0.2,1);
datablock ProjectileData(FusionBlasterTracerProjectile)
{
   //projectileShapeName = "./bullet.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::FusionBlaster;
   radiusDamageType    = $DamageType::FusionBlaster;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0; //400
   verticalImpulse	  = 0; //400
   //explosion           = FusionBlasterExplosion;
   particleEmitter     = FusionBlasterTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 200; //4000
   fadeDelay           = 100; //3500
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ProjectileData(FusionBlasterExplosionProjectile)
{
   //projectileShapeName = "./bullet.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::FusionBlaster;
   radiusDamageType    = $DamageType::FusionBlaster;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 2000; //400
   verticalImpulse	  = 100; //400
   explosion           = FusionBlasterExplosion;
   particleEmitter     = FusionBlasterTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 200; //4000
   fadeDelay           = 100; //3500
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(FusionBlasterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BSFusionBlaster.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Fusion Blaster";
	iconName = "./icon_FusionBlaster";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = FusionBlasterImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FusionBlasterImage)
{
   // Basic Item properties
   shapeFile = "./BSFusionBlaster.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = FusionBlasterTracerProjectile;
   projectileType = Projectile;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = FusionBlasterItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 20; //200
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = FusionBlasterExplosionProjectile;
   raycastExplosionBrickSound = FusionBlasterHitSound;
   raycastExplosionPlayerSound = FusionBlasterHitSound;
   raycastDirectDamage = 200;
   raycastDirectDamageType = $DamageType::FusionBlaster;
   raycastSpreadAmt = 0.00075; //varies
   raycastSpreadCount = 1;
   raycastTracerProjectile = FusionBlasterTracerProjectile;
   raycastFromMuzzle = true;


   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateSequence[1]                 = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.04;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= FusionBlasterFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= FusionBlasterShot1Sound;
	stateEjectShell[2]              = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= FusionBlasterSmokeEmitter;
	stateEmitterTime[3]				= 1.25;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 2;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateTimeoutValue[4]            = 0.03;
	stateTransitionOnTriggerDown[4]   = "Fire";
	stateTransitionOnTriggerUp[4]     = "Ready";
};

function FusionBlasterImage::onFire(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);
	if(%obj.getDamagePercent() >= 1.0)
		return;

		%this.raycastSpreadAmt = 0.0001; //0.0009
		%this.raycastWeaponRange = 40; //60


	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	%obj.playThread(2, shiftAway);	
}
