datablock AudioProfile(RailgunFireSound)
{
   filename    = "./Railgun_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunHitSound)
{
   filename    = "./Railgun_hit.wav";
   description = AudioClose3d;
   preload = true;
};

//muzzle flash effects
datablock ParticleData(RailgunsFlashParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -2.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 65;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.75 1.0 0.9";
	colors[1]     = "1.0 1.0 1.0 0.8";
	colors[2]	  = "1.0 0.75 0.25 0.7";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;
	sizes[2]      = 4.0;
	times[0]	= 0.0;
	times[1]	= 0.75;
	times[2]	= 1.0;
	

	useInvAlpha = false;
};
datablock ParticleEmitterData(RailgunsFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 200.0;
   velocityVariance = 25.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RailgunsFlashParticle";
};

datablock ParticleData(Railgunsexplosionparticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.75 1.0 0.9";
	colors[1]	  = "1.0 0.75 0.25 0.7";
	sizes[0]      = 12;
	sizes[1]      = 8;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Railgunsexplosionemitter)
{
	lifeTimeMS = 100;

   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Railgunsexplosionparticle";
};

datablock ParticleData(RailgunsExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/lighting/flare.jpg";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.75 1.0 0.9";
	colors[1]	  = "1.0 0.75 0.25 0.7";
	sizes[0]      = 16.0;
	sizes[1]      = 12.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RailgunsExplosionRingEmitter)
{
	lifeTimeMS = 300;

   ejectionPeriodMS = 12;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RailgunsExplosionRingParticle";

};

datablock ExplosionData(RailgunsExplosion)
{
   //explosionShape = "";
	soundProfile = RailgunHitSound;

   lifeTimeMS = 150;

   particleEmitter = RailgunsExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = RailgunsExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 2;
   lightStartColor = "0.5 1.0 0.9";
   lightEndColor = "0 0 0";
};


AddDamageType("Railguns",   '<bitmap:add-ons/Player_Mech/CI_Railguns> %1',    '%2 <bitmap:add-ons/Player_Mech/CI_Railguns> %1',0.2,1);
datablock ProjectileData(RailgunsProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Railguns;
   radiusDamageType    = $DamageType::Railguns;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400; //400
   verticalImpulse	  = 400; //400
   explosion           = RailgunsExplosion;
   particleEmitter     = RailgunsTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 175; //90
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(RailgunsItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BSRailgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Railguns";
	iconName = "./icon_Railguns";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = RailgunsImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RailgunsImage)
{
   // Basic Item properties
   shapeFile = "./BSRailgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = RailgunsProjectile;
   projectileType = Projectile;

	casing = RailgunsShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = RailgunsItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   
      raycastWeaponRange = 1200; //200
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = RailgunsProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 800;
   raycastDirectDamageType = $DamageType::Railguns;
   raycastSpreadAmt = 0.00075; //varies
   raycastSpreadCount = 1;
   //raycastTracerProjectile = RailgunsProjectile;
   raycastFromMuzzle = true;

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ReloadAll";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateScript[1]  = "OnReady";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.09;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = Railgunfiresound;
   stateEmitter[2]					= RailgunsFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

   stateName[3] = "Smoke";
  	stateAllowImageChange[3] = false; 
	stateEmitter[3]					= burstcannonSmokeEmitter;
	stateEmitterTime[3]				= 3.0;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerDown[4] = "FireAkimbo"; //stateTransitionOnTriggerUp
	stateSequence[4] = "ready";

	stateName[5] = "FireAkimbo";
	stateTimeoutValue[5] = 0.01;
	stateScript[5] = "onFireAkimbo";
	stateAllowImageChange[5] = false;
	stateTransitionOnTimeOut[5] = "reloadAll";
	
	stateName[6]             = "ReloadAll";
	stateScript[6]           = "onReload";
	statetimeoutValue[6]     = 4;
	stateTransitiononTimeout[6] = "Ready";
};

function RailgunsImage::onFire(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);	
	if(%obj.getDamagePercent() >= 1.0)
		return;

		%this.raycastSpreadAmt = 0.00001; //0.0018
		%this.raycastWeaponRange = 600;

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	%obj.playThread(2, shiftright);	
}

function RailgunsImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}

datablock ShapeBaseImageData(LeftRailgunsImage)
{
   // Basic Item properties
   shapeFile = "./BSRailgunLeft.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = RailgunsProjectile;
   projectileType = Projectile;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = true;
   colorShiftColor = RailgunsImage.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

      raycastWeaponRange = 1200; //200
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = RailgunsProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 800;
   raycastDirectDamageType = $DamageType::Railguns;
   raycastSpreadAmt = 0.00075; //varies
   raycastSpreadCount = 1;
   //raycastTracerProjectile = RailgunsProjectile;
   raycastFromMuzzle = true;
   
   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";
   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.09;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = Railgunfiresound;
   stateEmitter[2]					= RailgunsFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

   stateName[3] = "Smoke";
   	stateAllowImageChange[3] = false;
	stateEmitter[3]					= burstcannonSmokeEmitter;
	stateEmitterTime[3]				= 3.00;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 4.0;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "ready";


};

function LeftRailgunsImage::onFire(%this, %obj, %slot)
{
 //  Parent::onFire(%this,%obj,%slot);
 //  if(%obj.getDamagePercent() < 1.0)
	//	%obj.playThread(2, leftrecoil);
		if(%obj.getDamagePercent() >= 1.0)
		return;

		%this.raycastSpreadAmt = 0.00001; //0.0018
		%this.raycastWeaponRange = 600;

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	else if(%this.item.maxAmmo == 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	%obj.playThread(2, shiftleft);	
}

function RailgunsImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftRailgunsImage, 1);
   //%obj.playThread(0, armreadyboth);
//   	%obj.pushDatablock(BSMechNoJetArmor.getID());
}
function RailgunsImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
//   %obj.popDatablock(BSMechNoJetArmor.getID());
}


function LeftRailgunsImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftRailgunsImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}

function RailgunsImage::onReload(%this, %obj, %slot, %charge)
{
 commandToClient(%obj.client,'bottomPrint',"<just:right><color:5B73C9>-[Charging]-", 4, 2, 3, 4); 
}

function RailgunsImage::onReady(%this, %obj, %slot, %charge)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><color:00ff00>-[Charge Complete]-", 4, 2, 3, 4); 
}

