datablock AudioProfile(RocketPodShot1Sound)
{
   filename    = "./RocketPodFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RocketPodExplosionSound)
{
   filename    = "./RocketPodExplosion.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RocketPodLoopSound)
{
   filename    = "./RocketPodRocketLoop.wav";
   description = AudioClose3d;
   preload = true;
};


//muzzle flash effects
datablock ParticleData(FWRLFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 100.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.4 0.1 0.9";
	colors[1]     = "0.9 0.5 0.2 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FWRLFlashEmitter)
{
   ejectionPeriodMS = 2; //10
   periodVarianceMS = 0;
   ejectionVelocity = 40.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "FWRLFlashParticle";

   uiName = "FWRL Flash";
};

datablock ParticleData(FWRLSmokeParticle)
{
	dragCoefficient      = 15;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 250;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "1 0.4 0.1 0.0";
	colors[1]     = "1 0.7 0.3 0.9";
	colors[2]     = "1 0.7 0.3 0.9";
	colors[3]     = "1 1 1 0.0";

	sizes[0]      = 0.75; //0.25
   sizes[1]      = 1.0;  //1.0
	sizes[2]      = 2; //1.75
	sizes[3]      = 4;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 0.75;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FWRLSmokeEmitter)
{
   ejectionPeriodMS = 10; //50
   periodVarianceMS = 0;
   ejectionVelocity = -70.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0; //25
   phiReferenceVel  = 0;
   phiVariance      = 1;
   overrideAdvance = false;
   particles = "FWRLSmokeParticle";

   uiName = "FWRL Smoke";
};

datablock ParticleData(RocketPodTrailParticle)
{
	dragCoefficient      = 1.5; //3
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 800;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 100.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.86 0.46 0.1 0.9";
	colors[1]     = "0.51 0.09 0 0.7";
	colors[2]     = "0.5 0.5 0.5 0.2";
	colors[3]     = "0.1 0.1 0.1 0.1";
	
	sizes[0]      = 0.8;
	sizes[1]      = 0.3;
	sizes[2]      = 0.3;
    sizes[3]      = 1.25;
    
	times[0]      = 0.0;
    times[1]      = 0.05;
    times[2]      = 0.1;
	times[3]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RocketPodTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180; //90
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RocketPodTrailParticle";

   uiName = "RocketPod Trail";
};

datablock ParticleData(RocketPodSparkParticle)
{
	dragCoefficient      = 4; //3
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 1500;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 100.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1 1 0.86 0.9";
	colors[1]     = "0.78 0.34 0.04 0.7";
    colors[2]     = "0.1 0.1 0.1 0.0";
	
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;
	sizes[2]      = 0.2;
    
	times[0]      = 0.0;
	times[1]      = 0.5;
    times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RocketPodSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 75;
   velocityVariance = 20.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180; //90
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RocketPodSparkParticle";

   uiName = "RocketPod Sparks";
};

datablock ParticleData(RocketPodExplosionParticle)
{
	dragCoefficient      = 7;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.2 0.2 0.2 0.6";
	colors[1]     = "0.1 0.1 0.1 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 25.0;
    times[0]      = 0.0;
    times[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(RocketPodExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RocketPodExplosionParticle";

   uiName = "RocketPod Explosion Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(RocketPodExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 70.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.91 0.59 0.9";
	colors[1]     = "0.7 0.25 0.02 0.9";
	sizes[0]      = 3;
	sizes[1]      = 30;
	times[1]      = 0.0;
	times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RocketPodExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 10.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RocketPodExplosionRingParticle";

   uiName = "RocketPod Explosion Flash";
};

datablock ExplosionData(RocketPodExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = RocketPodExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = RocketPodExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = RocketPodExplosionRingEmitter;
   emitter[1] = RocketPodSparkEmitter;

   faceViewer     = true;
   explosionScale = "2 2 2";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 20;
   lightEndRadius = 5;
   lightStartColor = "1 0.9 0 1";
   lightEndColor = "1 0.3 0.1 0";

   damageRadius = 8; //3.5
   radiusDamage = 50;

   impulseRadius = 3;
   impulseForce = 2750;
};


AddDamageType("RocketPodDirect",   '<bitmap:add-ons/player_mech/CI_RocketPod> %1',    '%2 <bitmap:add-ons/player_mech/CI_RocketPod> %1',1,1);
AddDamageType("RocketPodRadius",   '<bitmap:add-ons/player_mech/CI_RocketPodRadius> %1',    '%2 <bitmap:add-ons/player_mech/CI_RocketPodRadius> %1',1,0);
datablock ProjectileData(RocketPodProjectile)
{
     projectileShapeName = "./RocketPodRocket.dts";
   directDamage        = 50;
   directDamageType = $DamageType::RocketPodDirect;
   radiusDamageType = $DamageType::RocketPodRadius;
   impactImpulse	   = 1000; //4000
   verticalImpulse	   = 1000; //4000
   explosion           = RocketPodExplosion;
   particleEmitter     = RocketPodTrailEmitter;

   brickExplosionRadius = 2;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = RocketPodLoopSound;

   muzzleVelocity      = 85; //150
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod          = 0.50; //0.005

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "RocketPod Rocket";
};

//////////
// item //
//////////
datablock ItemData(RocketPodItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BSRocketPod.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Rocket Pod";
	iconName = "./icon_RocketPod";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = RocketPodImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RocketPodImage)
{
   // Basic Item properties
   shapeFile = "./BSRocketPod.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = RocketPodProjectile;
   projectileType = Projectile;

	casing = RocketPodShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = RocketPodItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateScript[1]                   = "onReady";
	stateSequence[1]                 = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.04;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= FWRLFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= RocketPodShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= RocketPodSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.75; //0.01
	stateTransitionOnTimeout[3]     = "ReadyTwo";

	stateName[4]			= "Reload";
	stateScript[4]                 = "onReload";
	stateTimeoutValue[4]            = 2;
	stateTransitionOnTimeout[4]   = "Ready";
	
	stateName[5]                     = "ReadyTwo";
	stateSequence[5]                 = "Ready";
	stateTransitionOnTriggerDown[5]  = "FireTwo";
	stateAllowImageChange[5]         = true;
	
	stateName[6]                    = "FireTwo";
	stateTransitionOnTimeout[6]     = "SmokeTwo";
	stateTimeoutValue[6]            = 0.04;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateScript[6]                  = "onFireTwo";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= FWRLFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= RocketPodShot1Sound;
	stateEjectShell[6]              = true;

	stateName[7]                    = "SmokeTwo";
	stateEmitter[7]					= RocketPodSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzleNode";
	stateTimeoutValue[7]            = 0.75;
	stateTransitionOnTimeout[7]     = "ReadyThree";
	
		stateName[8]                     = "ReadyThree";
	stateSequence[8]                 = "Ready";
	stateTransitionOnTriggerDown[8]  = "FireThree";
	stateAllowImageChange[8]         = true;
	
	stateName[9]                    = "FireThree";
	stateTransitionOnTimeout[9]     = "SmokeThree";
	stateTimeoutValue[9]            = 0.04;
	stateFire[9]                    = true;
	stateAllowImageChange[9]        = false;
	stateScript[9]                  = "onFireThree";
	stateWaitForTimeout[9]			= true;
	stateEmitter[9]					= FWRLFlashEmitter;
	stateEmitterTime[9]				= 0.05;
	stateEmitterNode[9]				= "muzzleNode";
	stateSound[9]					= RocketPodShot1Sound;
	stateEjectShell[9]              = true;

	stateName[10]                    = "SmokeThree";
	stateEmitter[10]					= RocketPodSmokeEmitter;
	stateEmitterTime[10]				= 0.75;
	stateEmitterNode[10]				= "muzzleNode";
	stateTimeoutValue[10]            = 0.01;
	stateTransitionOnTimeout[10]     = "Reload";
};

function RocketPodImage::onReady(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><color:00ff00>Rockets:[<color:ffff00>0<color:00ff00>]" @ " " @ "[<color:ffff00>0<color:00ff00>]" @ " " @ "[<color:ffff00>0<color:00ff00>]", 4, 2, 3, 4); 
}

function RocketPodImage::onReload(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><color:5B73C9>Reloading...", 4, 2, 3, 4); 
}

function RocketPodImage::onFire(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);
commandToClient(%obj.client,'bottomPrint',"<just:right><color:00ff00>Rockets:[<color:ff0000>X<color:00ff00>]" @ " " @ "[<color:ffff00>0<color:00ff00>]" @ " " @ "[<color:ffff00>0<color:00ff00>]", 4, 2, 3, 4); 	

	%projectile = RocketPodProjectile;
	
		%spread = 0; //0.0035

	
	%shellcount = 1;

	%obj.playThread(2, shiftright);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function RocketPodImage::onFiretwo(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);
commandToClient(%obj.client,'bottomPrint',"<just:right><color:00ff00>Rockets:[<color:ff0000>X<color:00ff00>]" @ " " @ "[<color:ff0000>X<color:00ff00>]" @ " " @ "[<color:ffff00>0<color:00ff00>]", 4, 2, 3, 4); 

	%projectile = RocketPodProjectile;
	
		%spread = 0; //0.0035

	
	%shellcount = 1;

	%obj.playThread(2, shiftright);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function RocketPodImage::onFirethree(%this,%obj,%slot)
{
//	%spread = 0.002; //0.005
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftright);
//	Parent::onFire(%this,%obj,%slot);
commandToClient(%obj.client,'bottomPrint',"<just:right><color:00ff00>Rockets:[<color:ff0000>X<color:00ff00>]" @ " " @ "[<color:ff0000>X<color:00ff00>]" @ " " @ "[<color:ff0000>X<color:00ff00>]", 4, 2, 3, 4); 	

	%projectile = RocketPodProjectile;
	
		%spread = 0; //0.0035

	
	%shellcount = 1;

	%obj.playThread(2, shiftright);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
